<script lang="ts">
    import { createEventDispatcher } from 'svelte'
    import user from '$lib/user'
    import type { District, PlanetField } from '$utils/API/Planet.type'

    export let field: PlanetField = null

    const dispatch = createEventDispatcher()
    const isDistrict = (field: PlanetField): field is District => field && field.type === 'district'
</script>

{#if field === null}
    <div class="cell" on:click={() => dispatch('selectEmpty')} />
{:else if isDistrict(field)}
    <div
        class="cell district"
        class:mine={field.owner === $user.username}
        title="{field.name} owned by {field.owner} from the {field.faction}"
        on:click={() => dispatch('selectDistrict', field)}
        on:keydown={() => dispatch('selectDistrict', field)}
        tabindex="0"
    />
{:else}
    <div
        class="cell stargate-{field.color}"
        on:click={() => dispatch('selectStargate', field)}
        on:keydown={() => dispatch('selectDistrict', field)}
        title="{field.color} stargate"
        tabindex="0"
    />
{/if}

<style lang="postcss">
    .cell {
        aspect-ratio: 1;
        @apply bg-tile-default;
    }
    .district {
        @apply bg-tile-blue;
    }
    .stargate {
        &-red {
            @apply bg-tile-red;
        }
        &-yellow {
            @apply bg-tile-yellow;
        }
        &-orange {
            @apply bg-tile-orange;
        }
        &-violet {
            @apply bg-tile-violet;
        }
    }
    .mine {
        @apply bg-green-400;
    }
</style>
